export declare type List<T, P> = {
    head: Heap<T, P>;
    next: List<T, P>;
} | undefined;
export declare type Heap<T, P> = {
    entry: [T, P];
    subHeaps: List<T, P>;
};
export declare type MaybeHeap<T, P> = Heap<T, P> | undefined;
export declare function merge<T, P>(a: MaybeHeap<T, P>, b: MaybeHeap<T, P>, comparator: (a: P, b: P) => number): MaybeHeap<T, P>;
export declare function mergePairs<T, P>(list: List<T, P>, comparator: (a: P, b: P) => number): MaybeHeap<T, P>;
export declare function insert<T, P>(heap: MaybeHeap<T, P>, element: T, priority: P, comparator: (a: P, b: P) => number): Heap<T, P>;
export declare function deleteMin<T, P>(heap: Heap<T, P>, comparator: (a: P, b: P) => number): MaybeHeap<T, P>;
