"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function merge(a, b, comparator) {
    if (!a) {
        return b;
    }
    else if (!b) {
        return a;
    }
    else if (comparator(a.entry[1], b.entry[1]) < 0) {
        return { entry: a.entry, subHeaps: { head: b, next: a.subHeaps } };
    }
    else {
        return { entry: b.entry, subHeaps: { head: a, next: b.subHeaps } };
    }
}
exports.merge = merge;
function mergePairs(list, comparator) {
    if (!list) {
        return undefined;
    }
    else if (!list.next) {
        return list.head;
    }
    else {
        return merge(merge(list.head, list.next.head, comparator), mergePairs(list.next.next, comparator), comparator);
    }
}
exports.mergePairs = mergePairs;
function insert(heap, element, priority, comparator) {
    return merge(heap, { entry: [element, priority], subHeaps: undefined }, comparator);
}
exports.insert = insert;
function deleteMin(heap, comparator) {
    return mergePairs(heap.subHeaps, comparator);
}
exports.deleteMin = deleteMin;
//# sourceMappingURL=PairingHeap.js.map